<?php
/**
 * @edit       :dong
 * @data       :2023/02/27
 * @reason     :  云星辰2.0
 * @description:
 */
crm_load_class_file('cls_exch_data_erp', 'include');
crm_load_class_file('cls_exch_jdyisv2', 'include');

class cls_exch_data_erp_jdyisv2 extends cls_exch_data_erp
{
    public $erpModuleName;
    public $cls_exch_jdyisv;
    public $ListsInfos; //本次请求的所有是数据集合 用于获取分录数据

    public function __construct($exch_data, $erp_db_obj)
    {
        parent::__construct($exch_data, $erp_db_obj);
        $this->cls_exch_jdyisv2 = new cls_exch_jdyisv2($this->crm_module, $this->exchaccount);
        $this->erpModuleName = $this->frommodule ?: $this->cls_exch_jdyisv2->crmModuleToErpModule($this->crm_module);
    }

    public function getOptionExchData(): array
    {
        if ($this->sessionStatus == 'no') {
            $needGetDataArr = array_column($this->toObtainData, 'erp_id', 'erp_id');
        } else {
            $result_data = $this->get_erp_exch_data();
            if (empty($result_data)) {
                $msg = '数据同步：【' . strtoupper($this->exch_mode) . '】' . $this->exch_name . '没有查询到需要对接的数据！【' . date('Y-m-d H:i:s') . '】';
                saveErpLog($msg);
                ConvertTojsonString(2, '本次没有需要同步的数据', 'success'); //'本次没有需要同步的数据'
            }
            $result_data = array_column($result_data, null, $this->primaryKey);
            if ($this->sessionStatus == 'yes') {
                $this->insertExchDataLog($result_data);
            }
            //只获取需要同步的数据，写入exchdata_log表
            if (!empty($_REQUEST['get_exchdata']) && $_REQUEST['get_exchdata'] == 'yes') {
                crm_load_class_file('cls_exchaccount', 'include');
                $this->cls_exchaccount = new cls_exchaccount($this->exchaccount['crmaccount_id']);//同步模块信息
                $this->cls_exchaccount->updateDateTime($this->exch_id, $this->exchaccount['exchbill_id'], $this->exch_mode);
                ConvertTojsonString(2, '获取数据完成！', 'success');
            }

            $needGetDataArr = array_slice($result_data, 0, GETDATAMAXNUM, true);
            //云星辰获取的总数据不存储到session  每次从数据库中获取需同步的数据
            //$needSaveToSEESIOMData = array_slice($result_data,GETDATAMAXNUM,NULL,true);
            //$this->setDateToSESSION($needSaveToSEESIOMData);
        }

        /*        if ($this->erpModuleName == 'bd_material') {
                //支持一次获取多条数据
                    //产品能批量获取产品 其他单据单个获取
                    //批量获取最多每次100条 把数组分割
                    $ids = array_column($needGetDataArr,'id');
                    $idsArr = array_chunk($ids, 100);
                    $needOptionData = [];
                    foreach ($idsArr as $newids) {
                        $datas = $this->cls_exch_jdyisv->getProductInfoBatch($newids);
                        $needOptionData = array_merge($needOptionData, $datas);
                        $tmpArr = array_combine(array_column($newids, 'id'), $datas);
                        $this->ListsInfos = array_merge($tmpArr, $this->ListsInfos);
                    }

                }*/
        //云星辰获取本次需要同步的数据。
        $needOptionData = [];
        $key = 0;
        foreach ($needGetDataArr as $id => $item) {
            // @edit:dong @date:2022/07/12 @reason: 每10条暂停0。1秒 防止提示调用频率过快
            if (($key + 1) % 10 == 0) {
                sleep(0.1);
            }
            //if($key >10 )continue;
            $res = $this->cls_exch_jdyisv2->getErpModuleDetail($this->erpModuleName, $id);
            if (!$res) {
                // @edit:dong @date:2023/01/09 @reason: 查询不到数据直接写入日志中 不进行接下来步骤
                $this->exchdata_log->updateStatus($id, array('exchtime' => microDateTime(), 'fid' => -1, 'error_msg' => 'ERP未查询到数据'));
            } else {
                //echo json_encode($res);die;
                $needOptionData[] = $res;
                $this->ListsInfos[$id] = $res;//用户保存从erp获取到的信息。用于分录的字段映射取值
            }
            $key++;
        }

        return $this->optionExchData($needOptionData);
    }

    public function get_erp_exch_data()
    {
        $this->erp_exchtime = microDateTime();
        $search = '';
        if ($_REQUEST['testType'] == 'appoint' && $_REQUEST['billno']) {
            //指定单据同步
            $this->last_exchtime = '';
            $search = $_REQUEST['billno'];
            if ($_REQUEST['erpid']) $erpid = $_REQUEST['erpid'];
        }
        $return = $this->cls_exch_jdyisv2->getErpModuleList($this->erpModuleName, $this->last_exchtime, $this->erp_billrange, $search, $erpid);
        $return = array_column($return, null, 'id');
        //erp-crm过滤条件实现
        if (!empty($return)) $return = $this->filterApiResult($return);
        //随机一条
        if ($_REQUEST['testType'] == 'round' && $return) {
            $key = array_rand($return, 1);
            $return = array($key => $return[$key]);
        }
        return $return;
    }

    public function optionExchData($result_data): array
    {
        if (!empty($result_data)) {
            if (empty($this->ListsInfos)) {
                $this->ListsInfos = $result_data;
            }
            $PrimaryKey = $this->primaryKey;
            foreach ($result_data as $row) {
                // @edit:dong @date:2023/06/07 @reason: 自定义字段直接从$row['custom_field'] 提取到$row中
                if ($row['custom_field']) {
                    $row = array_merge($row, $row['custom_field']);
                }
                //收款单金蝶为双分录  把收款账户等内容进行组合
                //其他收入单 其他支出  其他收入退款单
                if (in_array($this->erpModuleName, ['ar_creditbill', 'ap_paybill', 'ar_creditretbill', 'ap_payretbill']) || in_array($this->erpModuleName, ['ar_othercreditbill', 'ap_otherpaybill', 'ar_othercreditretbill'])) {
                    if (in_array($this->erpModuleName, ['ar_creditbill', 'ap_paybill', 'ar_creditretbill', 'ap_payretbill'])) {
                        $tmpEntryField = 'pay_entry_list';
                    } else {
                        $tmpEntryField = 'instantpayfromtoentry';
                    }
                    // @edit:dong @date:2024/03/18 @reason:   接口分录名称由payfromtoentry改为pay_entry_list
                    foreach ($row[$tmpEntryField] as $payentery) {
                        foreach ($payentery as $key => $value) {
                            if (in_array($key, array('id', 'seq',))) continue;
                            if (in_array($key, ['amount', 'amount_for', 'servicefee', 'instant_amount'])) {
                                $row[$key] += $value;
                            } else {
                                if ($row[$key] == '') {
                                    $row[$key] .= $value;
                                } else {
                                    $row[$key] .= ',' . $value;
                                }
                            }
                        }
                    }
                    unset($row[$tmpEntryField]);
                }
                //销售订单收款分录取第一行收款金额
                if ($this->erpModuleName == 'sal_bill_order') {
                    if ($row['payment_entry'][0]) {
                        $row['pay_amount']=$row['payment_entry'][0]['pay_amount'];
                    }
                    unset($row['payment_entry']);
                }
                if ($this->crm_module == 'Products') {
                    // @edit:dong @date:2022/05/24 @reason: 产品批发价特殊处理
                    // @edit:dong @date:2023/10/31 @reason:价格只取第一行 有概率多分录
                    if ($row['price_entity'][0]) {
                        unset($row['price_entity'][0]['id']);
                        $row = array_merge($row, $row['price_entity'][0]);
                    }
                    unset($row['price_entity']);
                }
                //dump($row);die;
                foreach ($this->exch_data_head as $columnnames => $exch_data) {
                    if (empty($columnnames)) continue;
                    //echo $columnnames . '<br>';
                    $db_columnname = explode('__', $columnnames);
                    if (sizeOf($db_columnname) == 2) {
                        $value = $row[$db_columnname[1]];
                    } else {
                        $len = strlen($db_columnname[0] . '__');
                        $db_col = substr($columnnames, $len);
                        $value = $row[$db_col];
                        //后面使用的是$db_columnname[1]，在这里将db_col赋给$db_columnname[1]
                        $db_columnname[1]=$db_col;
                    }
                    if ($value === false) $value = 0;
                    if ($value === true) $value = 1;
                    //商品类型，普通：1、套装：2、服务：3   只有这三种状态
                    if (!empty($value) && in_array(strtolower($db_columnname[1]), array('check_type'))) {
                        $value = array(
                                     '1' => '普通',
                                     '2' => '套装',
                                     '3' => '服务',
                                 )[$value];
                    }
                    //@edit:zhaosk @date:2024/11/26 @reason: XUQIU20241112-01 金蝶云星辰OpenAPI隐私安全发布，密文传输，数据到CRM中需要解密
                    $value=$this->handleEncryptedField(array('value'=>$value,'columnName'=>$db_columnname[1]));//解密

                    if (!empty($value) && $this->erpModuleName == 'bd_material') {
                        switch (strtolower($db_columnname[1])) {
                            case 'parent_id':
                            case 'parent_number':
                                //产品类别
                                //parent_id 好像在详情里面不返回了
                                $useField = explode('_', strtolower($db_columnname[1]))[1] == 'id' ? 'id' : 'number';
                                $value = $this->cls_exch_jdyisv2->transMaterialgroup('name', $useField, $value);
                                break;
                            case 'parent_parent_id':
                            case 'parent_parent_number':
                                $useField = explode('_', strtolower($db_columnname[1]))[2] == 'id' ? 'id' : 'number';
                                if ($useField == 'id') {
                                    $tmpInfo = $this->cls_exch_jdyisv2->getErpModuleDetail('materialgroup', $row['parent_id']);
                                } else {
                                    $tmpInfo = $this->cls_exch_jdyisv2->getErpModuleDetail('materialgroup', '', $row['parent_number']);
                                }
                                $value = $this->cls_exch_jdyisv2->transMaterialgroup('name', 'id', $tmpInfo['parent_id']);
                                break;
                            case 'stock_id':
                                $value = $this->cls_exch_jdyisv2->transStore('name', 'id', $value);
                                break;
                            case 'brand_id':
                                $value = $this->cls_exch_jdyisv2->transMaterialBrand('name', 'id', $value);
                                break;
                            case 'space_id': //仓位
                                $value = $this->cls_exch_jdyisv2->transSpaces('name', 'id', $value);
                                break;
                            case 'vender_id':
                                $value = $this->cls_exch_jdyisv2->transSupplier('name', 'id', $value);
                                break;
                            default:
                                break;
                        }
                    }
                    //客户类别
                    if (!empty($value) && $this->erpModuleName == 'bd_customer' && in_array(strtolower($db_columnname[1]), array('group_id', 'group_number'))) {
                        $useField = explode('_', strtolower($db_columnname[1]))[1] == 'id' ? 'id' : 'number';
                        $value = $this->cls_exch_jdyisv2->transCustomerGroup('name', $useField, $value);
                    }
                    if ($exch_data['source_getvaluemethod'] == 'Default') {
                        $value = $exch_data['source_getvaluestring'];
                    }

//                    特殊设置  不同账套不同字段判断书写在此方法中
                    $value = $this->specialSetting($exch_data, $value);

                    $data[$row[$PrimaryKey]][$columnnames] = array(
                        'getvaluemethod' => $exch_data['target_getvaluemethod'],
                        'getvaluestring' => $exch_data['target_getvaluestring'],
                        'crm_fieldvariable' => $this->preg($exch_data['crm_fieldvariable']),
                        'value' => $value,
                        'allow_pri' => $exch_data['allow_pri'],
                        'log_label' => $exch_data['log_label'],
                    );
                }
//                收款单 云星辰的收款单的源单只能是出库单 源单不存在无法同步
                $data[$row[$PrimaryKey]]['details'] = $this->get_erp_exch_data_entry($PrimaryKey, $row[$PrimaryKey]);
            }
        }
        //dump($data);die;
        return $data;
    }

    /**
     * Name: 不同账套不同字段判断书写在此方法中
     * User: Dong
     * Date: 2022/3/16 14:23
     * @param $exch_data array
     * @param $value     string
     *
     */
    public function specialSetting($exch_data, $value)
    {
        return $value;
    }

    //获取分录明细的数据
    public function get_erp_exch_data_entry($PrimaryKey, $fid, $type = '')
    {
        if (empty($this->exch_data_entry)) return '';
        if ($this->crm_module == 'CashBill') {
            //return '';
            $entryField = 'selbillinfoentry';
        } else {
            $entryField = 'material_entity';
        }
        if ($this->frommodule == 'ar_precreditbill' || $this->frommodule == 'ar_othercreditretbill') {
            $entryField = 'pay_entry_list';
        }
//        收款单 源单分录
        if ($this->frommodule == 'ar_creditbill' || $this->erpModuleName == 'ar_creditbill') {
            $entryField = 'source_bill_entry_list';
        }
        if (!empty($this->ListsInfos[$fid])) {
            //dump($this->ListsInfos[$fid][$entryField]);die;
            foreach ($this->ListsInfos[$fid][$entryField] as $i => $row) {
                // @edit:dong @date:2023/06/07 @reason: 自定义字段直接从$row['custom_entity_field'] 提取到$row中
                if ($row['custom_entity_field']) {
                    $row = array_merge($row, $row['custom_entity_field']);
                }
                foreach ($this->exch_data_entry as $columnnames => $exch_data) {
                    if (empty($columnnames)) continue;
                    $db_columnname = explode('__', $columnnames);
                    // @edit:dong @date:2023/07/12 @reason: 自定义字段分割会出现多个导致匹配错误
                    if (sizeOf($db_columnname) == 2) {
                        $value = $row[$db_columnname[1]];
                    } else {
                        $len = strlen($db_columnname[0] . '__');
                        $db_col = substr($columnnames, $len);
                        $value = $row[$db_col];
                    }
                    if ($exch_data['source_getvaluemethod'] == 'Default') {
                        $value = $exch_data['source_getvaluestring'];
                    }
                    $entry_data[$fid][$i][$columnnames] = array(
                        'getvaluemethod' => $exch_data['target_getvaluemethod'],
                        'getvaluestring' => $exch_data['target_getvaluestring'],
                        'crm_fieldvariable' => $this->preg($exch_data['crm_fieldvariable']),
                        'value' => $value,
                    );
                }
            }
        }
        return $entry_data;
    }


    //获取模块表的主键
    public function getPrimaryKey($db_tablename): string
    {
        return 'id';
    }

    /**
     * 校验从ERP获取的数据是否含有隐私加密字段，进行解密操作，返回解密后的字段值
     * @edit:zhaosk
     * @date:2024/11/26
     */
    public function handleEncryptedField($params)
    {
        //源数据
        $encryptedValue='';
        if(isset($params['value'])){
            $encryptedValue=$params['value'];
        }
        $decryptedValue='';
        $isEncrypted=false;//标识
        //解密
        if(!empty($encryptedValue)){
            //字段名
            $columnName=$params['columnName'];

            switch($this->erpModuleName){
                case 'bd_customer'://客户
                    switch($columnName){
                        case 'bank_account'://银行账号
                        case 'addr'://详细地址
                        case 'mobile'://手机
                        case 'phone'://座机
                        case 'wechat'://微信
                        case 'contact_address'://地址
                        case 'birthday'://生日
                        case 'email'://邮箱
                        case 'qq'://QQ
                            $isEncrypted=true;
                            break;
                        default:
                            $isEncrypted=false;
                            break;
                    }
                    break;
                case 'sal_bill_order'://销售订单
                    switch($columnName){
                        case 'contact_address'://客户联系地址
                        case 'contact_phone'://客户联系电话
                        case 'dispatcher_address'://发货详细地址
                        case 'dispatcher_phone'://发货联系电话
                            $isEncrypted=true;
                            break;
                        default:
                            $isEncrypted=false;
                            break;
                    }
                    break;
                case 'sal_bill_outbound'://销售出库
                    switch($columnName){
                        case 'contact_address'://客户联系地址
                        case 'contact_phone'://客户联系电话
                        case 'dispatcher_address'://发货详细地址
                        case 'dispatcher_phone'://发货联系电话
                            $isEncrypted=true;
                            break;
                        default:
                            $isEncrypted=false;
                            break;
                    }
                    break;
                case 'sal_bill_inbound'://销售退货
                    switch($columnName){
                        case 'contact_address'://客户联系地址
                        case 'contact_phone'://客户联系电话
                            $isEncrypted=true;
                            break;
                        default:
                            $isEncrypted=false;
                            break;
                    }
                    break;
                case 'sal_inbound_request'://销售退货申请
                    switch($columnName){
                        case 'contact_address'://客户联系地址
                        case 'contact_phone'://客户联系电话
                            $isEncrypted=true;
                            break;
                        default:
                            $isEncrypted=false;
                            break;
                    }
                    break;
                case 'sal_bill_entrust'://委托代销单
                    switch($columnName){
                        case 'contact_address'://客户联系地址
                        case 'contact_phone'://客户联系电话
                        case 'dispatcher_address'://发货详细地址
                        case 'dispatcher_phone'://发货联系电话
                            $isEncrypted=true;
                            break;
                        default:
                            $isEncrypted=false;
                            break;
                    }
                    break;
                case 'pur_bill_request'://采购申请
                    switch($columnName){
                        case 'dispatcher_address'://收货联系地址
                        case 'dispatcher_phone'://收货联系电话
                            $isEncrypted=true;
                            break;
                        default:
                            $isEncrypted=false;
                            break;
                    }
                    break;
                case 'pur_bill_order'://采购订单
                    switch($columnName){
                        case 'contact_address'://发货联系地址
                        case 'contact_phone'://发货联系电话
                        case 'dispatcher_address'://收货联系地址
                        case 'dispatcher_phone'://收货联系电话
                            $isEncrypted=true;
                            break;
                        default:
                            $isEncrypted=false;
                            break;
                    }
                    break;
                case 'pur_bill_inbound'://采购入库
                    switch($columnName){
                        case 'contact_address'://发货联系地址
                        case 'contact_phone'://发货联系电话
                        case 'dispatcher_address'://收货联系地址
                        case 'dispatcher_phone'://收货联系电话
                            $isEncrypted=true;
                            break;
                        default:
                            $isEncrypted=false;
                            break;
                    }
                    break;
                case 'pur_bill_outbound'://采购退货
                    switch($columnName){
                        case 'contact_address'://供应商收货联系地址
                        case 'contact_phone'://供应商收货联系电话
                            $isEncrypted=true;
                            break;
                        default:
                            $isEncrypted=false;
                            break;
                    }
                    break;
                case 'inv_other_bill_inbound'://其他入库单
                    switch($columnName){
                        case 'contact_address'://供应商/客户联系地址
                        case 'contact_phone'://供应商/客户联系电话
                            $isEncrypted=true;
                            break;
                        default:
                            $isEncrypted=false;
                            break;
                    }
                    break;
                case 'bd_supplier'://供应商
                    switch($columnName){
                        case 'income_acc_no'://银行账号
                        case 'mobile'://手机
                        case 'phone'://座机
                        case 'wechat'://微信
                        case 'contact_address'://地址
                        case 'birthday'://生日
                        case 'income_bank_code'://开户行号
                        case 'email'://邮箱
                        case 'qq'://QQ
                            $isEncrypted=true;
                            break;
                        default:
                            $isEncrypted=false;
                            break;
                    }
                    break;
                case 'bd_employee'://职员
                    switch($columnName){
                        case 'id_number'://身份证号
                        case 'mobile'://手机号码
                        case 'birthday'://生日
                        case 'email'://邮箱
                        case 'wechat'://微信
                            $isEncrypted=true;
                            break;
                        default:
                            $isEncrypted=false;
                            break;
                    }
                    break;
                default:
                    $isEncrypted=false;
                    break;
            }
            //当前字段为隐私字段
            if($isEncrypted){
                $decryptedValue=$this->cls_exch_jdyisv2->decryptedJdyisv2(array('encryptedValue'=>$encryptedValue));
            }
            //当前字段非加密
            else{
                $decryptedValue=$encryptedValue;
            }
        }
        //字段值为空不解密
        else{
            $decryptedValue=$encryptedValue;
        }
        return $decryptedValue;
    }
}

?>