<?php
/**
 * User: Dong
 * Project: CRM链接ERP  云星辰isv 2.0
 * Date: 2021/2/3 11:25
 * Description:
 */

class cls_exch_jdyisv2
{
    public $crm_module;    //当前同步模块
    public $exchaccount_info;    //配置参数信息
    public $provinces;//省市区数组
    public $erpInfo;
    public $cachePrefix;
    /**
     * @var int 调用api接口次数用于判断是否需要从实时API获取过数据
     */
    public $getAppAuthNum = 0;

    public function __construct($crm_module, $exchaccount_info)
    {
        global $adb, $crmaccountinfo;  //crm账套id
        $this->crm_module = $crm_module;
        $this->crmaccountinfo = $crmaccountinfo;
        $this->exchaccount_info = $exchaccount_info;
        $this->setErpInfo();
        //dump($this->erpInfo);die;
        $this->cachePrefix = $exchaccount_info['exchbill_id'] . '_jdyisv2';
    }

    public function setErpInfo($type = false)
    {
        //erp_dbuser 存储appKey  如果非81mis的用户手动配置erp_dbuser字段 然后就可以正常使用。
        if (!$this->exchaccount_info['appsecret'] || $type) {
            // @edit:dong @date:2023/03/06 @reason: 初次配置直接获取
            $appAuthInfo = $this->getAppAuthorize();
            $this->exchaccount_info = array_merge($this->exchaccount_info, $appAuthInfo);
        }
        $this->reSetErpInfo();
    }

    public function reSetErpInfo()
    {
        $this->erpInfo = array(
            'url' => $this->exchaccount_info['erp_dbhost'],
            'client_id' => $this->exchaccount_info['appkey'],
            'client_secret' => $this->exchaccount_info['appsecret'],
            'appKey' => $this->exchaccount_info['erp_dbuser'],
            'externalNumber' => $this->exchaccount_info['custom1'],
            'appSecret' => $this->exchaccount_info['custom2'],
            "domain" => $this->exchaccount_info['custom1'],
            "outerInstanceId" => $this->exchaccount_info['orgid'],
        );
    }

    public function updateAppAuthorize($arr, $type)
    {
        global $adb;
        //custom2 存储 appSecret
        //erp_dbuser 存储 appKey
        //appkey 存储 client_id
        //appSecret 存储 lient_secret
        //orgid 存储 externalNumber
        //custom1 存储 domain
        //custom3 存储 groupname
        if ($type == '51mis') {
            $appInfo['erp_dbuser'] = $arr['appkey'];
            $appInfo['custom2'] = $arr['appsecret'];
            $appInfo['appkey'] = $arr['clientid'];
            $appInfo['appsecret'] = $arr['clientsecret'];
            $appInfo['orgid'] = $arr['outerinstanceid'];
            $appInfo['custom1'] = $arr['domain'];
            $appInfo['custom3'] = $arr['groupname'];
            $appInfo['custom6'] = $arr['accountid'];
            $update = 'update exchaccount set erp_dbuser=?,custom2 = ?,appkey=?,appsecret=?,orgid=?,custom1=?,custom3=?,custom6=? where id=' . $this->exchaccount_info['exchbill_id'];
            $adb->pquery($update, array($appInfo['erp_dbuser'], $appInfo['custom2'], $appInfo['appkey'], $appInfo['appsecret'], $appInfo['orgid'], $appInfo['custom1'], $appInfo['custom3'], $appInfo['custom6']));
        } else if ($type == 'erp') {
            $appInfo['erp_dbuser'] = $arr['appKey'];
            $appInfo['custom2'] = $arr['appSecret'];
            $appInfo['appkey'] = $arr['clientId'];
            //$appInfo['appsecret'] = $arr['clientsecret'];
            $appInfo['orgid'] = $arr['outerInstanceId'];
            // $appInfo['custom1'] = $arr['domain'];
            $appInfo['custom3'] = $arr['groupName'];
            $appInfo['custom6'] = $arr['accountId'];
            $update = 'update exchaccount set erp_dbuser=?,custom2 = ?,appkey=?,orgid=?,custom3=?,custom6=? where id=' . $this->exchaccount_info['exchbill_id'];
            $adb->pquery($update, array($appInfo['erp_dbuser'], $appInfo['custom2'], $appInfo['appkey'], $appInfo['orgid'], $appInfo['custom3'], $appInfo['custom6']));
        }

        return $appInfo;

    }

    //获取app权限信息
    public function getAppAuthorize()
    {
        // @edit:dong @date:2023/03/07 @reason: 处理url防止客户填写不带www和带www的域名造成获取不到权限
        $crmurlPath = parse_url($this->crmaccountinfo['crm_loginurl'])['path'];
        $appkey = $this->exchaccount_info['erp_dbuser'];
        if (empty($crmurlPath) && empty($appkey)) {
            ConvertTojsonString(-1, '', __FILE__ . ':' . __LINE__ . ' ' . __METHOD__ . '获取APP的订阅信息信息需要的参数错误');
        }
        $tmpAppInfo = LdPost('https://www.51mis.cn/webapi/yunxingchen/getJdyisvAppAuthInfo.php', array('urlpath' => $crmurlPath, 'appkey' => $appkey))['result'];
        // $tmpAppInfo['appkey']=1;
        if (!$tmpAppInfo['appkey']) {
            ConvertTojsonString(-1, '', __FILE__ . ':' . __LINE__ . ' ' . __METHOD__ . '无法获取51mis上的APP的订阅信息信息 请检查');
        }
        return $this->updateAppAuthorize($tmpAppInfo, '51mis');
    }

    /**
     * 单据保存方法
     * @param $erpModuleName
     * @param $data
     * @return mixed|void
     * @throws Exception
     */
    public function saveErpModuleData($erpModuleName, $data)
    {
        $url = $this->makeErpApiUrl($erpModuleName, 'save');
        return $this->curlUrl($url, 'POST', $data);
    }

    //批量审核
    public function cloud_approve($id, $erp_module, $type = 'audit')
    {
//        https://open.jdy.com/#/files/api/detail?index=2&categrayId=1f51c576013945e2af68ef15d4245a48&id=277b35b087664372ac27a0dc53534fa1
        //操作类型，删除delete、审核audit、反审核unaudit、作废invalid、取消作废valid
        $url = $this->erpInfo['url'] . '/jdy/v2/sys/common_operate';
        $data = json_encode(array(
            'ids' => array($id),
            'ignore_warn' => true, //是否忽略告警信息(如：名称已存在)保存客户，true:忽略，默认false
            'entity_number' => $erp_module,
            'operate_type' => $type //操作类型，删除delete、审核audit、反审核unaudit、订单关闭close_donothing
        ));
        return $this->curlUrl($url, 'POST', $data);
    }

    public function getErpList($erpModuleName, $param = [])
    {
        $pageField = 'page';
        if ($erpModuleName == 'invoice_fp') $pageField = 'page_no';
        $url = $this->makeErpApiUrl($erpModuleName, 'list');
        if ($param) {
            $trueUrl = $url . '?' . http_build_query($param);
        } else {
            $trueUrl = $url;
        }
        $result = $this->curlUrl($trueUrl);
        if ($result['errcode'] != 0) {
            ConvertTojsonString(-1, '', __FILE__ . ':' . __LINE__ . ' ' . __METHOD__ . '  descrpiton：' . $result['description'] . $result['description_cn'] . ' url:' . $url);
        }

        $rowArr = $result['data']['rows']; //返回的数据集合
        $pages = $result['data']['total_page']; //本次需要 获取的总页数
        if ($pages != 1) {
            for ($i = 2; $i <= $pages; $i++) {
                $param[$pageField] = $i;
                $trueUrl = $url . '?' . http_build_query($param);
                $result = $this->curlUrl($trueUrl);
                $rowArr = array_merge($rowArr, $result['data']['rows']);
            }
        }
        return $rowArr;
    }

    /**
     * Name: 获取ERP 模块列表数据
     * User: Dong
     * Date: 2023/8/30 16:15
     * @param $erpModuleName
     * @param $lastExchTime
     * @param $billstatus
     * @param $search
     * @return array|mixed
     */
    public function getErpModuleList($erpModuleName, $lastExchTime = '', $billstatus = '', $search = '', $erpid = '')
    {
        if (!$lastExchTime) $lastExchTime = '1990-01-01';
        if (!empty($billstatus)) $billstatus = 'C'; //单据状态（所有：“”，已审核：“C”，未审核：“Z”）

        $time = strtotime($lastExchTime) . '000';
        // @edit:dong @date:2023/06/07 @reason: create_start_time和modify_start_time 同时使用 modify_start_time不起作用
        // @edit:dong @date:2023/08/30 @reason: https://open.jdy.com/#/conent/index?id=59
        $data = array(
            //"create_start_time" => (int)$time, //创建时间-开始时间的时间戳(毫秒)
            "modify_start_time" => (int)$time, //修改时间-开始时间的时间戳(毫秒)
            "page_size" => 100  //最大支持100
        );
        if (substr($erpModuleName, 0, 2) == 'bd') {
            $data['enable'] = 1;//可用状态，1：可用，0：禁用, -1：全部
            if ($erpid) {
                $data['ids'] = $erpid;  //erpid
            } else {
                $data['search'] = $search;  //模糊搜索-名称、编码、规格、条形码
            }

        } else if ($erpModuleName == 'ar_creditbill' || $erpModuleName == 'ap_otherpaybill' || $erpModuleName == 'ar_othercreditbill') {
            $data['bill_status'] = $billstatus;//单据状态（所有：“”，已审核：“C”，未审核：“Z”）
            $data['search'] = $search;  //模糊搜索-名称、编码、规格、条形码
        } else if ($erpModuleName == 'invoice_fp') {
            /**
             * start_date    string    false    发票起始日期(yyyy-MM-dd)
             * end_date    string    false    发票终止日期(yyyy-MM-dd)
             * invoice_type    array    false    发票类型(0:普通发票,1:专用发票)
             * invoice_status    array    false    发票状态(0:正常 1:失控 2:作废 3:红冲 4:异常)
             * invoice_no    array    false    发票号码
             * customer    array    false    客户名称
             * bill_type    array    false    单据类型(0:销项发票 1:进项发票 2:其它可抵扣发票)
             * page_no    integer    false    页码
             * page_size    integer    false    页面大小
             */
            unset($data['modify_start_time']);
            $data['start_date'] = date('Y-m-d', substr($time, 0, -3));
            $data['end_date'] = date('Y-m-d');
            $data['page_no'] = 1;

        } else {
            $data['bill_no'] = $search;  //业务单据支持编码查询
            $data['bill_status'] = $billstatus;//单据状态（所有：“”，已审核：“C”，未审核：“Z”）
        }
        return $this->getErpList($erpModuleName, $data);
    }


    /**
     * 出库单获取发票单号和时间
     * Name: https://open.jdy.com/#/files/api/detail?index=3&categrayId=3cc8ee9a663e11eda5c84b5d383a2b93&id=a863f5d3758811efb84d63f2856478b5
     * User: Dong
     * Date: 2024/9/18 16:31
     * @param $billno
     * @return mixed
     */
    public function getErpInviceInfoByOutboundOrder($billno)
    {
        $url = $this->erpInfo['url'] . '/jdy/v2/fp/invoice_kp_query';
        $param = ['bill_no' => $billno];
        if ($param) {
            $trueUrl = $url . '?' . http_build_query($param);
        } else {
            $trueUrl = $url;
        }
        $result = $this->curlUrl($trueUrl);
        if ($result['errcode'] != 0) {
            ConvertTojsonString(-1, '', __FILE__ . ':' . __LINE__ . ' ' . __METHOD__ . '  descrpiton：' . $result['description'] . $result['description_cn'] . ' url:' . $url);
        }
        //返回的数据集合
        return $result['data']['rows'];
    }


    /**
     * Name: id number 二选一 id优先
     * User: Dong
     * Date: 2023/3/24 09:20
     * @param $erpModuleName
     * @param $id
     * @param string $number
     * @return false|mixed
     */
    public function getErpModuleDetail($erpModuleName, $id, string $number = '')
    {
        $numberField = 'number';
        if ($erpModuleName == 'invoice_fp') $numberField = 'invoice_no';
        $url = $this->makeErpApiUrl($erpModuleName, 'detail');
        if ($id == '' && $number) {
            $url = $url . '?' . http_build_query(array($numberField => $number));
        } else {
            $url = $url . '?' . http_build_query(array('id' => $id));
        }
        $result = $this->curlUrl($url);
        /**
         * Array
         * (
         * [description] => 请求接口返回失败:您要读取的数据在系统中不存在,可能已经被删除！
         * [errcode] => 1000002001
         * )
         * Array
         * (
         * [description] => 请求接口返回失败:参数number [SMJ230300007] 不存在！
         * [errcode] => 1000002001
         * )
         */
        if ($result['errcode'] == '1000002001') return false;
        if ($result['errcode'] != 0) {
            ConvertTojsonString(-1, '', __FILE__ . ':' . __LINE__ . ' ' . __METHOD__ . ' descrpiton：' . $result['description'] . $result['description_cn'] . ' url:' . $url);
        }

        return $result['data'];
    }

    public function getInvByIds($ids = [])
    {
        if (empty($ids)) return [];
        $url = $this->erpInfo['url'] . '/jdy/v2/scm/inventory';
        $urlStringArr = [];
        $urlString = '';
        foreach ($ids as $id) {
            $urlStringArr[] = 'material_ids=' . $id;
        }
        $urlString = implode('&', $urlStringArr);
        $trueUrl = $url . '?' . $urlString;

        $result = $this->curlUrl($trueUrl);

        if ($result['errcode'] != 0) {
            ConvertTojsonString(-1, '', __FILE__ . ':' . __LINE__ . ' ' . __METHOD__ . '  descrpiton：' . $result['description'] . $result['description_cn'] . ' url:' . $url);
        }
        $rowArr = $result['data']['rows']; //返回的数据集合

        return $rowArr;
    }


    //获取产品库存
    public function getInvList($exchtime)
    {
        $time = strtotime($exchtime) . '000';
        $url = $this->erpInfo['url'] . '/jdy/v2/scm/inventory';
        $data = array(
            "create_start_time" => (int)$time, //创建时间-开始时间的时间戳(毫秒)
            "modify_start_time" => (int)$time, //修改时间-开始时间的时间戳(毫秒)
            "page_size" => 100  //最大支持100
        );
        $trueUrl = $url . '?' . http_build_query($data);
        $result = $this->curlUrl($trueUrl);
        if ($result['errcode'] != 0) {
            ConvertTojsonString(-1, '', __FILE__ . ':' . __LINE__ . ' ' . __METHOD__ . '  descrpiton：' . $result['description'] . $result['description_cn'] . ' url:' . $url);
        }
        $rowArr = $result['data']['rows']; //返回的数据集合
        $pages = $result['data']['total_page']; //本次需要 获取的总页数
        if ($pages != 1) {
            for ($i = 2; $i <= $pages; $i++) {
                $data['page'] = $i;
                $trueUrl = $url . '?' . http_build_query($data);
                $result = $this->curlUrl($trueUrl);
                $rowArr = array_merge($rowArr, $result['data']['rows']);
            }
        }
        return $rowArr;
    }

    /**
     * 使用api获取数据 并转换 第一次缓存获取 第二次使用api实时获取
     * @param $function //方法名
     * @param string $name
     * @param string $id
     * @param bool $type // fasle 取缓存，true api获取
     * @return mixed
     *
     */
    public function transformation($function, string $name = '', string $id = '', bool $type = false)
    {
        $returnString = $this->$function($name, $id, $type);
        if (empty($returnString)) {
            $returnString = $this->$function($name, $id, true);
        }
        return $returnString;
    }

    //辅助资料分类列表
    function getAuxInfoType($type = false)
    {
        $erpModuleName = 'aux_info_type';
        $key = $this->cachePrefix . 'kdyaux_info_type';
        $AuxInfoList = cache($key);
        if (empty($AuxInfoList) || $type) {
            $data = array(
                "page_size" => 100
            );
            $AuxInfoList = $this->getErpList($erpModuleName, $data);
            cache($key, $AuxInfoList);
        }
        return $AuxInfoList;
    }

    //辅助资料列表
    function getAuxInfo($type = false)
    {
        $erpModuleName = 'aux_info';
        $key = $this->cachePrefix . 'kdyaux_info';
        $AuxInfoList = cache($key);
        if (empty($AuxInfoList) || $type) {
            $data = array(
                "page_size" => 100
            );
            $AuxInfoList = $this->getErpList($erpModuleName, $data);
            cache($key, $AuxInfoList);
        }
        return $AuxInfoList;
    }
    //辅助资料
    // group  1-客户等级 2-交货方式 3-退货原因 4-其它入库类型 5-其它出库类型
    /**
     * @param string $name
     * @param string $id
     * @param bool $type
     * @param $group  string 辅助资料的分组id
     * @return mixed|string|void
     *                $exch_data['custom_field__4__375nch1ogd0m_id'] = $this->cls_exch_jdyisv2->getAuxInfoList($exch_data['custom_field__4__375nch1ogd0m_id'], '', false,'1662245600504091648');
     */
    public function getAuxInfoList(string $name = '', string $id = '', bool $type = false, string $group = '')
    {
        if ($name == '' && $id == '') return '';
        $key = $this->cachePrefix . 'kdyauxinfolist' . $group;
        $AuxInfoList = cache($key);
        if (empty($AuxInfoList) || $type) {
            $erpModuleName = 'aux_info';
            // $data['search'] = $name;
            if ($group) {
                $data['group'] = $group;
            }
            $data['page_size'] = 1000;
            $AuxInfoList = $this->getErpList($erpModuleName, $data);
            cache($key, $AuxInfoList);
        }
        if (!empty($name)) {
            $newArr = array_column($AuxInfoList, 'id', 'name');
            if (!$newArr[$name] && !$type) {
                return $this->getAuxInfoList($name, $id, true, $group);
            }
            return $newArr[$name];
        }
        if (!empty($id)) {
            $newArr = array_column($AuxInfoList, 'name', 'id');
            if (!$newArr[$id] && !$type) {
                return $this->getAuxInfoList($name, $id, true, $group);
            }
            return $newArr[$id];
        }

        return $AuxInfoList;
    }

    //转化客户字段
    public function transCustomer($needField, $useField, $useFieldValue)
    {
        $key = $this->cachePrefix . 'kdycustomerlist';
        $erpModuleName = 'bd_customer';
        return $this->getCacheData($needField, $useField, $useFieldValue, $key, $erpModuleName);
    }

    //转化供应商字段
    public function transSupplier($needField, $useField, $useFieldValue)
    {
        /**
         * id    String    供应商ID
         * number    String    供应商编码
         * name    String    供应商名称
         * group_id    String    供应商分类id
         * group_name    String    供应商分类名称
         * group_number    String    供应商分类编码
         * rate    String    税率
         * bank    String    开户银行
         * bankaccount    String    银行账号
         * accountopenaddr    String    开户地址
         */
        $key = $this->cachePrefix . 'kdysupplierlist';
        $erpModuleName = 'bd_supplier';
        return $this->getCacheData($needField, $useField, $useFieldValue, $key, $erpModuleName);
    }

    //仓库字段
    public function transStore($needField, $useField, $useFieldValue)
    {
        /**
         * id    String    仓库ID
         * groupid_name    String    仓库分类名称
         * groupid_id    String    仓库分类id
         * groupid_number    String    仓库分类编码
         * number    String    仓库编码
         * name    String    仓库名称
         * isallowfreight    String    启用仓位管理，true/false
         * isallowneg    String    是否启用负库存，true/false
         * enable    String    状态，1代表启用，0代表禁用
         */
        $key = $this->cachePrefix . 'kdysettletypelist';
        $erpModuleName = 'bd_store';
        return $this->getCacheData($needField, $useField, $useFieldValue, $key, $erpModuleName);
    }

    public function transBoolean($value): bool
    {
        if (is_bool($value)) {
            return $value;
        }
        if (is_numeric($value)) {
            return $value == 1 ? true : false;
        }
        if ($value == '1' || $value == 'true' || $value == '是') return true;
        if ($value == '0' || $value == 'false' || $value == '否') return false;
        return $value;
    }

    public function transBoolean2($value): bool
    {
        //是否忽略告警信息(如：单价为0)保存订单，true:忽略，默认false
        if ($value) {
            return true;
        } else {
            return false;
        }
    }
    //仓位字段
    public function transSpaces($needField, $useField, $useFieldValue)
    {
        /**
         * "name":"名称",
         * "number":"001"
         */
        $key = $this->cachePrefix . 'kdyspaceslist';
        $erpModuleName = 'bd_spaces';
        return $this->getCacheData($needField, $useField, $useFieldValue, $key, $erpModuleName);
    }

    //商品转化字段bd_material
    public function transMaterial($needField, $useField, $useFieldValue)
    {
        $key = $this->cachePrefix . 'kdymateriallist';
        $erpModuleName = 'bd_material';
        return $this->getCacheData($needField, $useField, $useFieldValue, $key, $erpModuleName);
    }

    //结算方式
    public function transSettleType($needField, $useField, $useFieldValue)
    {
        /**
         * id    String    结算方式ID
         * name    String    结算方式名称
         * enable    String    可用状态，1 可用，0 不可用
         * isdefault    booelan    是否默认
         */
        $key = $this->cachePrefix . 'kdysettlement_typelist';
        $erpModuleName = 'settlement_type';
        return $this->getCacheData($needField, $useField, $useFieldValue, $key, $erpModuleName);
    }

    //支出类别
    public function transPayOutType($needField, $useField, $useFieldValue)
    {
        /**
         * id    String    支出类型ID
         * number    String    支出类型编码
         * name    String    支出类型名称
         * group_id    String    支出类型分类id
         * group_name    String    支出类型分类名称
         * group_number    String    支出类型分类编码
         */
        $key = $this->cachePrefix . 'kdypayouttypelist';
        $erpModuleName = 'payout_type';
        return $this->getCacheData($needField, $useField, $useFieldValue, $key, $erpModuleName);
    }

    //收入类别 paccttype_save // income_type
    public function transPaccttype($needField, $useField, $useFieldValue)
    {
        //收入类别	bd_paccttype
        /**
         * id    String    收入类别id
         * number    String    收入类别编码
         * name    String    收入类别名称
         */
        $key = $this->cachePrefix . 'kdypaccttypelist';
        $erpModuleName = 'paccttype';
        return $this->getCacheData($needField, $useField, $useFieldValue, $key, $erpModuleName);
    }

    //结算期限
    public function transSettlingterm($needField, $useField, $useFieldValue)
    {
        if (!$useFieldValue) return '';
        /**
         * id    String    结算期限ID
         * name    String    结算期限名称
         * enable    String    可用状态，1 可用，0 不可用
         */
        $key = $this->cachePrefix . 'kdysettingtermlist';
        $erpModuleName = 'settlingterm';
        return $this->getCacheData($needField, $useField, $useFieldValue, $key, $erpModuleName);
    }

    //科目
    public function transAccount($needField, $useField, $useFieldValue)
    {
        /**
         * dc    integer    借贷方向 1借方 -1贷方
         * enable    integer    是否启用 1-是 0-否
         * full_name    string    科目名称(全名)
         * help_code    string    助记码
         * id    string    科目id
         * is_assist    integer    是否辅助核算1-是 0-否
         * is_bank    integer    是否银行科目1-是 0-否
         * is_cash    integer    是否现金科目1-是 0-否
         * is_cash_equivalent    integer    是否现金等价物1-是 0-否
         * is_currency    integer    是否外币核算1-是 0-否
         * is_leaf    integer    是否明细 1明细科目 0非明细科目
         * is_qty    integer    是否数量核算1-是 0-否
         * level    integer    科目级次 1-n
         * name    string    科目名称
         * number    string    科目编码
         * pid    string    父级科目id 无父级为0
         */
        if (!$useFieldValue) return '';
        $key = $this->cachePrefix . 'kdyaccountlist';
        $erpModuleName = 'bd_account';
        return $this->getCacheData($needField, $useField, $useFieldValue, $key, $erpModuleName);
    }

    //部门
    public function transDepartment($needField, $useField, $useFieldValue)
    {
        if (!$useFieldValue) return '';
        /**
         * id    number    部门ID
         * number    String    部门编码
         * name    String    部门名称
         * longnumber    String    长编码
         * fullname    String    长名称
         * enable    String    启用状态，0：禁用，1：可用
         * level    String    级次，0：顶级
         * isleaf    String    是否子级，0：否，1：是
         * parent_id    String    上级部门id
         * parent_name    String    上级部门名称
         * parent_number    String    上级部门编码
         */
        $key = $this->cachePrefix . 'kdydeptlist';
        $erpModuleName = 'bd_department';
        return $this->getCacheData($needField, $useField, $useFieldValue, $key, $erpModuleName);
    }

    //物流公司
    public function transLogisticscompany($needField, $useField, $useFieldValue)
    {
        if (!$useFieldValue) return '';
        /**
         * id    String    物流公司id
         * number    String    物流公司编码
         * name    String    物流公司名称
         */
        $key = $this->cachePrefix . 'kdylogisticscompanylist';
        $erpModuleName = 'logisticscompany';
        return $this->getCacheData($needField, $useField, $useFieldValue, $key, $erpModuleName);
    }

    //客户分类
    public function transCustomerGroup($needField, $useField, $useFieldValue)
    {
        if (!$useFieldValue) return '';
        /**
         * id    String    类别id
         * name    String    类别名称
         * number    String    类别编码
         * parent_id    String    父级类别id
         * isleaf    String    是否叶子节点
         * level    String    级次
         * remark    String    备注
         */
        $key = $this->cachePrefix . 'kdycustomergrouplist';
        $erpModuleName = 'customergroup';
        return $this->getCacheData($needField, $useField, $useFieldValue, $key, $erpModuleName);
    }

    /**
     * Name: 商品类型，普通：1、套装：2、服务：3
     * User: Dong
     * Date: 2023/11/28 13:50
     * @param $needField
     * @param $useField
     * @param $value
     * @return mixed|void
     */
    public function transCheckType($needField, $useField, $value)
    {
        $array = array(
            '1' => '普通',
            '2' => '套装',
            '3' => '服务',
        );
        if ($needField == 'id') {
            if (in_array($value, ['1', '2', '3'])) return $value;
            $array = array_flip($array);
            return (string)$array[$value];
        }
        return $array[$value];
    }

    //商品产品类别分类
    public function transMaterialgroup($needField, $useField, $useFieldValue)
    {
        if (!$useFieldValue) return '';
        /**
         * id    string    id
         * is_leaf    boolean    是否叶子节点
         * level    string    级次
         * name    string    名称
         * number    string    编码
         */
        $key = $this->cachePrefix . 'kdyMaterialgrouplist';
        $erpModuleName = 'materialgroup';
        return $this->getCacheData($needField, $useField, $useFieldValue, $key, $erpModuleName);
    }

    //职员
    public function transEmployee($needField, $useField, $useFieldValue)
    {
        if (!$useFieldValue) return '';
        /**
         * id    number    职员ID
         * number    String    职员编码
         * name    String    职员名称
         * mobile    String    手机号码
         * idnumber    String    身份证号
         * enable    String    状态，1代表启用，0代表禁用
         */
        $key = $this->cachePrefix . 'kdyempLoyeelist';
        $erpModuleName = 'bd_employee';
        return $this->getCacheData($needField, $useField, $useFieldValue, $key, $erpModuleName);
    }

    //计量单位
    public function transMeasureUnit($needField, $useField, $useFieldValue)
    {
        if (!$useFieldValue) return '';
        /**
         * id    String    计量单位ID
         * number    String    计量单位编码
         * name    String    计量单位名称
         * precision    String    数量小数位
         */
        $key = $this->cachePrefix . 'kdymeasureunitlist';
        $erpModuleName = 'measure_unit';
        return $this->getCacheData($needField, $useField, $useFieldValue, $key, $erpModuleName);
    }

    //品牌 material_brand
    public function transMaterialBrand($needField, $useField, $useFieldValue)
    {
        if (!$useFieldValue) return '';
        /**
         * id    String    计量单位ID
         * number    String    计量单位编码
         * name    String    计量单位名称
         * precision    String    数量小数位
         */
        $key = $this->cachePrefix . 'kdymaterial_brandlist';
        $erpModuleName = 'material_brand';
        return $this->getCacheData($needField, $useField, $useFieldValue, $key, $erpModuleName);
    }

    //商品单位
    public function transMaterialUnit($needField, $useField, $useFieldValue)
    {
        if (!$useFieldValue) return '';
        /**
         * id    String    商品单位ID
         * materialid    String    商品ID
         * index    String    顺序
         * isdefault    String    是否默认，true/false
         * isfloat    String    是否浮动
         * coefficient    String    换算率
         * unitid_name    String    单位名称
         * unitid_id    String    单位id
         * conversionunitid_id    String    转换单位id
         * conversionunitid_name    String    转换单位名称
         */
        $key = $this->cachePrefix . 'kdymaterialunitlist';
        $erpModuleName = 'material_unit';
        return $this->getCacheData($needField, $useField, $useFieldValue, $key, $erpModuleName);
    }

    //存货的辅助属性转化
    public function transAuxProp($exch_data, $useField, $useFieldValue)
    {
        if ($useField != 'id' || !$useFieldValue || !$exch_data['material_id']) return '';
        $materialInfo = $this->getErpModuleDetail('bd_material', $exch_data['material_id']);
        if ($materialInfo['aux_entity']) {
            $tmpArr = array_column($materialInfo['aux_entity'], 'id', 'aux_combination_name');
            return $tmpArr[$useFieldValue];
        }
        return '';
    }
    //币别
    public function transCurrency($needField, $useField, $useFieldValue)
    {
        if (!$useFieldValue) return '';
        /**
         * id    String    币别ID
         * name    String    名称
         * number    String    编码
         * enable    String    是否启用，1:启用，0:禁用，：全部
         * rate    String    税率
         * priceprecision    String    单价小数位
         * amtprecision    String    金额小数位
         * exctype    String    汇率类型，1：固定汇率，2：浮动汇率
         */
        $key = $this->cachePrefix . 'kdycurrencylist';
        $erpModuleName = 'bd_currency';
        return $this->getCacheData($needField, $useField, $useFieldValue, $key, $erpModuleName);
    }

    //账户
    public function transBank($needField, $useField, $useFieldValue)
    {
        if (!$useFieldValue) return '';
        /**
         * id    number    false    结算账户id（修改结算账户时必填）
         * number    String    false    结算账户编码,不传递则由后台生成（不设置有编码规则和更新时必传）
         * name    String    true    结算账户名称
         * currencyid_number    String    true    币别,多个币别使用英文逗号隔开
         * account    String    false    银行账号
         * accountname    String    false    开户名
         * openingbank    String    false    开户行
         * remark    String    false    备注
         * isdefault    boolean    false    是否默认结算账户
         */
        $key = $this->cachePrefix . 'kdybanklist';
        $erpModuleName = 'bd_bank';
        return $this->getCacheData($needField, $useField, $useFieldValue, $key, $erpModuleName);
    }

    //客户联系人性别	性别（1-男 2-女）
    public function transGender($needField, $useField, $useFieldValue)
    {
        return array(
                   '男' => '1',
                   '女' => '2'
               )[$useFieldValue];
    }
    public function transInvoiceType($needField, $useField, $useFieldValue)
    {
        //1-纸质专票 2-纸质普票 3-电子普票 4-电子专票 5-全电普票 6-全电专票 0-无需开票
        $return = '';
        $return = array(
                   '纸质专票' => '1',
                   '纸质普票' => '2',
                   '电子普票' => '3',
                   '电子专票' => '4',
                   '全电普票' => '5',
                   '全电专票' => '6',
                   '无需开票' => '0',
               )[$useFieldValue];
        if ($return) {
            return $return;
        }
        // @edit:dong @date:2024/07/08 @reason: 新版本选项变多了。
        return array(
                   '纸质专票' => '1',
                   '纸质普票' => '2',
                   '电子普票' => '3',
                   '电子专票' => '4',
                   '数电普票' => '5',
                   '数电专票' => '6',
                   '数电纸普票' => '7',
                   '数电纸专票' => '8',
                   '无需开票' => '0',
               )[$useFieldValue];
    }
    //自定义字段
    public function getErpCustomField($crmModule = '', $erpModule = '', $type = 'cache')
    {
        $erpModule = $erpModule ?: $this->crmModuleToErpModule($crmModule);
        $key = $this->cachePrefix . __METHOD__ . '_' . $erpModule;
        $cacheResult = cache($key);
        if (!$cacheResult || $type == 'noCache') {
            $url = $this->erpInfo['url'] . '/jdy/v2/sys/custom_field';
            $data = array(
                "entity_number" => $erpModule
            );
            $url .= '?' . http_build_query($data);
            $apiResult = $this->curlUrl($url);
            $cacheResult = $apiResult['data'];
            cache($key, $cacheResult);
        }
        return $cacheResult;
    }

    //通过条件筛选后，把crm的值转化为erp的id
    public function transCrmValueToErpValueByParam($erpModuleName, $needField, $useField, $useFieldValue, $param = [])
    {
        /**
         * 代码实例
         * if($end_data['pay_type']=='管理费用'){
         * $group = '1658000658697057280';
         * }else{
         * $group = '1658020484341575680';
         * }
         *
         * $end_data['pay_type_id'] = $this->cls_exch_jdyisv2->transCrmValueToErpValueByParam('payout_type','id', 'name', $end_data['pay_type_id'],array('group'=>$group));
         */
        $dataArr = $this->getCacheDataAll($erpModuleName, $param);
        //dump($dataArr);//die;
        $tmpArr = array_column($dataArr, $needField, $useField);
        if (!array_key_exists($useFieldValue, $tmpArr)) {
            $dataArr = $this->getCacheDataAll($erpModuleName, $param, 'noCache');
            $tmpArr = array_column($dataArr, $needField, $useField);
        }
        //dump($erpModuleName,$needField,$useField,$useFieldValue,$param,$tmpArr[$useFieldValue]);die;
        return $tmpArr[$useFieldValue] ?: '';
    }

    /**
     * Name: 获取某一个单据的所有是数据
     * User: Dong
     * Date: 2023/5/11 09:50
     * @param $erpModuleName
     * @param array $param
     * @param string $type
     * @return array|mixed|string|void
     */
    public function getCacheDataAll($erpModuleName, array $param = [], string $type = 'cache')
    {
        $key = $this->cachePrefix . 'getCacheDataAll' . $erpModuleName . json_encode($param, 256);
        $returnArr = cache($key);
        if (empty($returnArr) || $type == 'noCache') {
            $returnArr = $this->getErpList($erpModuleName, $param);
            cache($key, $returnArr);
        }
        return $returnArr;
    }

    public function getCacheData($needField, $useField, $useFieldValue, $key, $erpModuleName, $type = 'cache')
    {
        $returnArr = cache($key);
        if (empty($returnArr) || $type == 'noCache') {
            $returnArr = $this->getErpModuleList($erpModuleName);
            cache($key, $returnArr);
        }
        $tmpArr = array_column($returnArr, $needField, $useField);
        if (!array_key_exists($useFieldValue, $tmpArr) && $this->getApiNum < 1) {
            $this->getApiNum = 1;
            return $this->getCacheData($needField, $useField, $useFieldValue, $key, $erpModuleName, 'noCache');
        } else {
            $this->getApiNum = 0;
            return $tmpArr[$useFieldValue] ?: '';
        }
    }

    //获取token
    public function getAccessToken($type = false)
    {
        $key = $this->cachePrefix . 'jdyisv';
        $accessToken = cache($key);
        if ($type || empty($accessToken) || ($accessToken['expire'] <= time() && $accessToken['app-token'])) {
            //https://open.jdy.com/#/files/api/detail?id=9cfa40a6714d11eda0b3d91be7d25699&noside=true
            $result = $this->getErpToken();
            //1030002012 appscrect 不对
            //1030002002  不存在的appKey
            //1030002006  授权秘钥检验失败，请获取最新密钥加密
            //1030002003 不存在的appKey : t3P27WQD
            if (in_array($result['errcode'], array('1030002012', '1030002006')) || in_array($result['code'], array('1030002002', '1030002003'))) {
                //主动获取
                $this->activeAuthorization();
                $result = $this->getErpToken();
            }
            /*if (in_array($result['errcode'], array('1030002012', '1030002006')) || in_array($result['code'], array('1030002002', '1030002003'))) {
                //防止请求过快
                sleep(1);
                //获取51mis上的
                $this->setErpInfo(true);
                $result = $this->getErpToken();
                if (in_array($result['errcode'], array('1030002012', '1030002006')) || in_array($result['code'], array('1030002002', '1030002003'))) {
                    //防止请求过快
                    sleep(1);
                    //主动获取
                    $this->activeAuthorization();
                    $result = $this->getErpToken();
                }
            }*/
            if ($result['errcode'] != 0) {
                ConvertTojsonString(-1, '', __FILE__ . ':' . __LINE__ . ' ' . __METHOD__ . '  descrpiton：' . $result['description'] . $result['description_cn'] . 'json:' . json_encode($result, 256) . microDateTime());
            }
            if ($result['code']) {
                //:{\"code\":1000001001,\"msg\":\"获取AuthCode失败，可通知客户登录小微工作台重试  需要授权的客户登录www.jdy.com\",\"data\":null}"}
                ConvertTojsonString(-1, '', __FILE__ . ':' . __LINE__ . ' ' . __METHOD__ . '  descrpiton：' . $result['msg'] . 'json:' . json_encode($result, 256) . microDateTime());
            }
            if ($result['data']['app-token']) {
                $accessToken['access_token'] = $result['data']['access_token'];
                $accessToken['app-token'] = $result['data']['app-token'];
                // 防止程序运行时 token失效  expires这字段有效时间好像不对
                //            $accessToken['expire'] = substr($result['data']['expires'], 0, -3) - 60;
                //            3小时获取一次
                $accessToken['expire'] = time() + 3 * 60 * 60;
                cache($key, $accessToken);
            }

        }
        return $accessToken['app-token'];
    }

    //直接获取token
    public function getErpToken()
    {
        $urlParam = '/jdyconnector/app_management/kingdee_auth_token';
        $param = array(
            "app_key" => $this->erpInfo['appKey'],
            "app_signature" => $this->HamcSHA256Base64($this->erpInfo['appKey'], $this->erpInfo['appSecret'])
        );
        $url = $this->erpInfo['url'] . $urlParam . '?' . http_build_query($param);
        $header = $this->makeCurlHead('GET', $url);
        $result = curl_post($url, '', 'GET', $header);
        /***
         * Array
         * (
         * [code] => 1000001001  出现原因 以前的管理员变更过导致无法获取
         * [msg] => https://tf.jdy.com/auth/isv-app获取app-token返回失败！ v7 services is null
         * [data] =>
         * )
         */
        return json_decode($result, true);
    }

    public function makeCurlHead($curlType, $url)
    {
        if (!in_array($curlType, array('GET', 'POST'))) {
            die(__FILE__ . __LINE__ . $curlType . ':错误');
        }
        $timestampArr = cache($this->cachePrefix . 'X-Api-TimeStamp');
        if (!$timestampArr || $timestampArr['expire'] < time()) {
            $timestampArr['timestamp'] = microDateTime('timestamp');
            $timestampArr['expire'] = time() + 3 * 60;
            cache($this->cachePrefix . 'X-Api-TimeStamp', $timestampArr);
        }
        $timestamp = $timestampArr['timestamp'];

        $urlInfo = parse_url($url);
        $urlParam = urlencode($urlInfo['path']);
        parse_str($urlInfo['query'], $queryArray);
        if ($urlInfo['query']) $urlQueryParam = explode('&', $urlInfo['query']);
        $EcryptionStrTmp = '';
        if (count($queryArray) == count($urlQueryParam)) {
            ksort($queryArray);  //按ASCII码升序顺序进行排序
            foreach ($queryArray as $k => $v) {
                $queryArray[$k] = urlencode($v);
            }
            $EcryptionStrTmp = http_build_query($queryArray);
        } else { // $urlInfo['query'] = 'group=1&group=2';
            $endNum = strlen((string)count($urlQueryParam));
            foreach ($urlQueryParam as $key => $value) {
                unset($urlQueryParam[$key]);
                if (strlen($key) != $endNum) $key = str_pad($key, 2, '0', STR_PAD_LEFT);
                $urlQueryParam[explode('=', $value)[0] . $key] = explode('=', $value)[1];
            }
            ksort($urlQueryParam);
            foreach ($urlQueryParam as $key => $value) {
                if ($EcryptionStrTmp) {
                    $EcryptionStrTmp .= '&' . substr($key, 0, $endNum * -1) . '=' . urlencode(urlencode($value));
                } else {
                    $EcryptionStrTmp .= substr($key, 0, $endNum * -1) . '=' . urlencode(urlencode($value));
                }
            }
        }
        $beforeEcryptionStr = $curlType . "\n" . $urlParam . "\n" . $EcryptionStrTmp . "\nx-api-nonce:" . $timestamp . "\nx-api-timestamp:" . $timestamp . "\n";
        $Signature = $this->HamcSHA256Base64($beforeEcryptionStr, $this->erpInfo['client_secret']);
        $header = array(
            'Content-Type:application/json',
            'X-Api-ClientID:' . $this->erpInfo['client_id'],
            'X-Api-Auth-Version:2.0',
            'X-Api-TimeStamp:' . $timestamp,
            'X-Api-SignHeaders:X-Api-TimeStamp,X-Api-Nonce',
            'X-Api-Nonce:' . $timestamp,
            'X-Api-Signature:' . $Signature,
        );
        if (strpos($urlInfo['path'], '/jdy/v2/') !== false) {
            $header[] = 'app-token:' . $this->getAccessToken();
            $header[] = 'X-GW-Router-Addr:' . $this->erpInfo['domain'];
        }
        return $header;
    }

    //进行HamcSHA256加密 以16进制输出，再进行Base64加密
    public function HamcSHA256Base64($string, $key): string
    {
        return base64_encode(hash_hmac('sha256', $string, $key));
    }


    public function curlUrl($url, $type = 'GET', $body = '')
    {
        $header = $this->makeCurlHead($type, $url);
        $output = curl_post($url, $body, $type, $header);
        $output = json_decode($output, true);
        //1000202001 token不对 因为appscrect变更了 token没更新的导致。
        if (in_array($output['errcode'], array('1000202001')) && $this->getAppAuthNum == 0) {
            $this->getAppAuthNum = 1;
            $this->getAccessToken(true);
            return $this->curlUrl($url, $type, $body);
        } elseif ($output['errcode'] == '1030002012' || $output['errcode'] == '4008') {
            //1030002012 是app秘钥不对。如果提示网关错误那就是 client_Secret 不对
            ConvertTojsonString(-1, '', __FILE__ . ':' . __LINE__ . ' ' . __METHOD__ . '  descrpiton：' . $output['description'] . $output['description_cn'] . ' url:' . $url . 'Json：' . json_encode($output));
        }

        // dump($output);die;
        return $output;
        /**
         * {
         * "description": "请求接口返回失败:SO213: 单据编号【so213】已存在，请修改",
         * "errcode": 1000002001
         * }
         */
    }

    //主动获取授权信息
    public function activeAuthorization()
    {
        $urlParam = '/jdyconnector/app_management/push_app_authorize';
        $param = array(
            "outerInstanceId" => $this->erpInfo['outerInstanceId']
        );
        $url = $this->erpInfo['url'] . $urlParam . '?' . http_build_query($param);
        $header = $this->makeCurlHead('POST', $url);
        $result = curl_post($url, '', 'POST', $header);
        $result = json_decode($result, true);
        if ($result['code'] != 200) {
            ConvertTojsonString(-1, '', __FILE__ . ':' . __LINE__ . ' ' . __METHOD__ . '  result：' . json_encode($result, 256) . ' url:' . $url);
        }
        $appAuthInfo = $this->updateAppAuthorize($result['data'][0], 'erp');
        $this->exchaccount_info = array_merge($this->exchaccount_info, $appAuthInfo);
        $this->reSetErpInfo();
    }

    /**
     * Generates the URL for the ERP API based on the ERP module and type.
     * 根据 ERP 模块和类型生成 ERP API 的 URL。
     *
     * @param string $erpModule The ERP module.
     * @param string $type The type of the ERP API.
     * @return string|null The URL for the ERP API.
     * @throws \Exception If the API address is not configured.
     */
    public function makeErpApiUrl($erpModule, $type): ?string
    {
        $erpApiArr = array(
            'bd_material' => array(
                'save' => 'bd/material',
                'detail' => 'bd/material_detail',
                'list' => 'bd/material',
            ), //物料
            'bd_customer' => array(
                'save' => 'bd/customer',
                'detail' => 'bd/customer_detail',
                'list' => 'bd/customer',
            ), //客户
            'bd_supplier' => array(
                'save' => 'bd/supplier',
                'detail' => 'bd/supplier_detail',
                'list' => 'bd/supplier',
            ), //供应商
            'bd_account' => array(
                'save' => 'fi/account',
                'detail' => 'fi/account_detail',
                'list' => 'fi/account',
            ), //科目
            'pur_bill_inbound' => array(
                'save' => 'scm/pur_inbound',
                'detail' => 'scm/pur_inbound_detail',
                'list' => 'scm/pur_inbound',
            ), //采购入库
            'pur_bill_order' => array(
                'save' => 'scm/pur_order',
                'detail' => 'scm/pur_order_detail',
                'list' => 'scm/pur_order',
                'cancel' => 'scm/pur_order_cancel',//订单取消（仅限通过外部ID操作），如采购、销售订单已审核，则关闭订单，如采购、销售订单未审核，则删除订单
            ), //采购订单
            'sal_bill_order' => array(
                'save' => 'scm/sal_order',
                'detail' => 'scm/sal_order_detail',
                'list' => 'scm/sal_order',
            ), //销售订单
            'sal_bill_outbound' => array(
                'save' => 'scm/sal_out_bound',
                'detail' => 'scm/sal_out_bound_detail',
                'list' => 'scm/sal_out_bound',
            ), //出库单
            'sal_bill_inbound' => array(
                'save' => 'scm/sal_in_bound',
                'detail' => 'scm/sal_in_bound_detail',
                'list' => 'scm/sal_in_bound',
            ), //销售退货
            'pur_bill_outbound' => array(
                'save' => 'scm/pur_ret',
                'detail' => 'scm/pur_ret_detail',
                'list' => 'scm/pur_ret',
            ), //采购退货
            'gl_voucher' => array(
                'save' => 'fi/voucher',
                'detail' => 'fi/voucher_detail',
                'list' => 'fi/voucher',
            ), //凭证
            'inv_other_bill_inbound' => array(
                'save' => 'scm/inv_other_in',
                'detail' => 'scm/inv_other_in_detail',
                'list' => 'scm/inv_other_in',
            ), //其他入库单
            'inv_other_bill_outbound' => array(
                'save' => 'scm/inv_other_out',
                'detail' => 'scm/inv_other_out_detail',
                'list' => 'scm/inv_other_out',
            ), //其他出库单
            'ar_creditbill' => array(
                'save' => 'arap/ar_credit',
                'detail' => 'arap/ar_credit_detail',
                'list' => 'arap/ar_credit',
            ), //收款单
            'ar_creditretbill' => array(
                'save' => 'arap/ar_credit_ret',
                'detail' => 'arap/ar_credit_ret_detail',
                'list' => 'arap/ar_credit_ret',
            ), //收款退款单
            'ap_payretbill' => array(
                'save' => 'arap/ap_pay_ret',
                'detail' => 'arap/ap_pay_ret_detail',
                'list' => 'arap/ap_pay_ret',
            ), //付款退款单
            'ar_precreditbill' => array(
                'save' => 'arap/ar_pre_credit',
                'detail' => 'arap/ar_pre_credit_detail',
                'list' => 'arap/ar_pre_credit',
            ), //预收款单
            'ap_paybill' => array(
                'save' => 'arap/ap_credit',
                'detail' => 'arap/ap_credit_detail',
                'list' => 'arap/ap_credit',
            ),//付款单
            'ar_othercreditbill' => array(
                'save' => 'arap/ar_other_credit',
                'detail' => 'arap/ar_other_credit_detail',
                'list' => 'arap/ar_other_credit',
            ), //其他应收单
            'ap_prepaybill' => array(
                'save' => 'arap/ap_pre_credit',
                'detail' => 'arap/ap_pre_credit_detail',
                'list' => 'arap/ap_pre_credit',
            ), //预付款单
            'ap_otherpaybill' => array(
                'save' => 'arap/ap_other_credit',
                'detail' => 'arap/ap_other_credit_detail',
                'list' => 'arap/ap_other_credit',
            ), //其他支出单
            'bd_store' => array(
                'save' => 'bd/store',
                'detail' => 'bd/store_detail',
                'list' => 'bd/store',
            ),
            'bd_spaces' => array(
                'save' => 'bd/spaces',
                'detail' => 'bd/space_detail',
                'list' => 'bd/spaces',
            ),
            'aux_type' => array(//辅助属性分类
                'save' => 'bd/aux_type',
                'list' => 'bd/aux_type',
            ),
            'aux_attribute' => array(//辅助属性分类
                'save' => 'bd/aux_attribute',
                'list' => 'bd/aux_attribute',
            ),
            'aux_info' => array(//辅助资料
                'save' => 'bd/aux_info',
                'detail' => 'bd/aux_info_detail',
                'list' => 'bd/aux_info',
            ),
            'aux_info_type' => array(//辅助资料分类
                'save' => 'bd/aux_info_type',
                'detail' => 'bd/aux_info_type_detail',
                'list' => 'bd/aux_info_type',
            ),
            //其他资料-支出类别
            'payout_type' => array(
                'list' => 'bd/payout_type',
                'save' => 'bd/payout_type',
            ),
            //其他资料-收入类别
            'income' => array(
                'list' => 'bd/income_type',
                'save' => 'bd/income_type',
            ),
            //其他资料-收入类别
            'paccttype' => array(
                'list' => 'bd/income_type',
                'save' => 'bd/income_type',
            ),
            //结算期限
            'settlingterm' => array(
                'list' => 'bd/settling_term',
                'save' => 'bd/settling_term',
                'detail' => 'bd/settling_term_detail',
            ),
            //部门
            'bd_department' => array(
                'list' => 'bd/department',
                'save' => 'bd/department',
                'detail' => 'bd/department_detail',
            ),
            //结算方式
            'settlement_type' => array(
                'list' => 'bd/settlement_type',
                'save' => 'bd/settlement_type'
            ),
            //职员
            'bd_employee' => array(
                'list' => 'bd/emp',
                'save' => 'bd/emp',
                'detail' => 'bd/emp_detail',
            ),
            //物流公司
            'logisticscompany' => array(
                'list' => 'bd/logistics_company',
                'save' => 'bd/logistics_company',
                'detail' => 'bd/logistics_company_detail',
            ),
            //客户分类
            'customergroup' => array(
                'list' => 'bd/customer_group',
                'save' => 'bd/customer_group',
            ),
            //产品分类
            'materialgroup' => array(
                'list' => 'bd/material_group',
                'save' => 'bd/material_group',
                'detail' => 'bd/material_group_detail',
            ),
            //计量单位
            'measure_unit' => array(
                'list' => 'bd/measure_unit',
                'save' => 'bd/measure_unit',
                'detail' => 'bd/measure_unit_detail',
            ),
            //商品单位
            'material_unit' => array(
                'list' => 'bd/material_unit',
                'detail' => 'bd/material_unit',
            ),
            //商品品牌
            'material_brand' => array(
                'list' => 'bd/material_brand',
                'detail' => 'bd/material_brand_detail',
                'save' => 'bd/material_brand',
            ),
            //币别
            'bd_currency' => array(
                'list' => 'bd/currency',
                'detail' => 'bd/currency_detail',
                'save' => 'bd/currency',
            ),
            //账户
            'bd_bank' => array(
                'list' => 'bd/settlement_account',
                'save' => 'bd/settlement_account',
            ),
            'sal_invoice' => array( //销售单据-销售发票
                                    'list' => 'scm/sal_invoice_list',
                                    'save' => 'scm/sal_invoice',
                                    'detail' => 'scm/sal_invoice_detail'
            ),
            'invoice_kp' => array( // 税务管理-开票管理
                                   'list' => 'fp/invoice_kp',
                                   'save' => 'fp/invoice_kp',
                                   'detail' => 'fp/invoice_kp_detail'
            ),
            'invoice_fp' => array( // 税务-发票管理-发票列表
                                   'list' => 'fi/invoice_fp',
                                   'detail' => 'fi/invoice_detail'
            )

        );
        if (!$erpApiArr[$erpModule][$type]) {
            ConvertTojsonString(-1, '', __METHOD__ . '单据' . $erpModule . $type . 'api地址没有配置');
        }
        return $this->erpInfo['url'] . '/jdy/v2/' . $erpApiArr[$erpModule][$type];
    }

    public function crmModuleToErpModule($crm_module): ?string
    {
        //https://open.jdy.com/#/files/api/detail?index=3&categrayId=3cc8ee9a663e11eda5c84b5d383a2b93&id=dd7ee492712611eda0b375f5553347df
        return array(
            'SalesOrder' => 'sal_bill_order',
            'Products' => 'bd_material',
            'Accounts' => 'bd_customer',
            'CashBill' => 'ar_creditbill',
            'Users' => 'bd_employee',
            'Contacts' => 'bd_customer',
            'OutboundOrder' => 'sal_bill_outbound',
            'SendCashBill' => 'ap_paybill',
            'PurchaseOrder' => 'pur_bill_order',
            'Stock' => 'pur_bill_inbound',
            'WareHouseTransfer' => 'inv_tfin_bill_inbound',
            'SalesBack' => 'sal_bill_inbound',
            'Vendors' => 'bd_supplier',
            'CashBack' => 'ar_creditretbill',
            'Groups' => 'bd_department',
        )[$crm_module];

    }


    public function getErpDivision($type = false)
    {
        $key = $this->cachePrefix . __METHOD__;
        $return = cache($key);
        if (empty($return) || $type) {
            $url = $this->erpInfo['url'] . '/jdy/v2/sys/division_load';
            $result = $this->curlUrl($url);
            cache($key, $result['data']['rows']);
            $return = $result['data']['rows'];
        }
        return $return;
    }

    public function transDivision($data, $type = false)
    {
        $divisionArr = $this->getErpDivision($type);
        // @edit:dong @date:2024/04/10 @reason: 客户表头地址转化
        if ($data['province_id']) {
            $tmpStr = $data['province_id'];
            $level1Arr = array_column($divisionArr, null, 'name');
            $data['province_id'] = $level1Arr[$tmpStr]['id'];
            $level2Arr = $level1Arr[$tmpStr]['son_nodes'];
            if ($data['city_id']) {
                $tmpStr = $data['city_id'];
                $level2Arr = array_column($level2Arr, null, 'name');
                $data['city_id'] = $level2Arr[$tmpStr]['id'];
                $level3Arr = $level2Arr[$tmpStr]['son_nodes'];
                if ($data['district_id']) {
                    $tmpStr = $data['district_id'];
                    $level3Arr = array_column($level3Arr, null, 'name');
                    $data['district_id'] = $level3Arr[$tmpStr]['id'];
                }
            }
        }
        // @edit:dong @date:2024/04/10 @reason: 客户联系人地址省市转化
        if ($data['contact_province_id']) {
            $tmpStr = $data['contact_province_id'];
            $level1Arr = array_column($divisionArr, null, 'name');
            $data['contact_province_id'] = $level1Arr[$tmpStr]['id'];
            $level2Arr = $level1Arr[$tmpStr]['son_nodes'];
            if ($data['contact_city_id']) {
                $tmpStr = $data['contact_city_id'];
                $level2Arr = array_column($level2Arr, null, 'name');
                $data['contact_city_id'] = $level2Arr[$tmpStr]['id'];
                $level3Arr = $level2Arr[$tmpStr]['son_nodes'];
                if ($data['contact_district_id']) {
                    $tmpStr = $data['contact_district_id'];
                    $level3Arr = array_column($level3Arr, null, 'name');
                    $data['contact_district_id'] = $level3Arr[$tmpStr]['id'];
                }
            }
        }
        return $data;
    }

    //废弃
    public function getProvince($name = '', $id = '', $type = false)
    {
        $key = $this->cachePrefix . 'kdyprovinces';
        $provinces = cache($key);
        if (empty($provinces) || $type) {
            $url = $this->erpInfo['url'] . '/jdy/v2/sys/division_load';
            $result = $this->curlUrl($url);
            $provinces = $this->loopMultArr($result['data']['rows']);
            cache($key, $provinces);
        }
        if (!empty($name)) {
            return $provinces[$name];
        }
        if (!empty($id)) {
            $provinces = array_flip($provinces);
            return $provinces[$name];
        }
        return $provinces;
    }

    /**
     * Name: 废弃
     * User: Dong
     * Date: 2023/11/1 16:17
     * @param $arr
     * @return mixed
     */
    public function loopMultArr($arr)
    {
        foreach ($arr as $info) {
            $arr[$info['name']] = $info['id'];
            if (!empty($info['son_nodes'])) {
                $this->loopMultArr($info['son_nodes']);
            }
        }
        return $arr;
    }

    /**
     * 云星辰隐私字段解密
     * @edit:zhaosk
     * @date:2024/11/26
     */
    public function decryptedJdyisv2($params)
    {
        $encryptedValue='';//待解密内容
        $decryptedValue='';//返回的解密内容
        if(isset($params['encryptedValue'])){
            $encryptedValue=$params['encryptedValue'];
        }
        if(!empty($encryptedValue)){
            $key=$this->erpInfo['client_secret'];
            if(empty($key)){
                //key为空直接return
                return '';
            }
            // 固定偏移量
            $iv = "5e8y6w45ju8w9jq8";

            // 将 base64 编码的密文解码
            $encryptedValue = base64_decode($encryptedValue);
            // 使用 AES 解密
            $decryptedValue = openssl_decrypt($encryptedValue, 'AES-256-CBC', $key, OPENSSL_RAW_DATA, $iv);
        }
        //字段值为空不解密
        else{
            $decryptedValue=$encryptedValue;
        }
        return $decryptedValue;
    }
}